%define		apiversion 0.7.0
%define         dialogversion    0.7.1
%define         pydialogversion 0.1
%define         plugins place,png,decoration,clone,fade,minimize,move,resize,switcher,scale
%define         gconfschemas %{_sysconfdir}/gnome/gconf/schemas/compiz-annotate.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-blur.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-clone.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-core.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-cube.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-dbus.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-decoration.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-fade.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-fs.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-gconf.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-glib.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-ini.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-inotify.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-minimize.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-move.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-place.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-plane.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-png.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-regex.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-resize.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-rotate.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-scale.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-screenshot.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-svg.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-switcher.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-video.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-water.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-wobbly.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/compiz-zoom.schemas \\\
                %{_sysconfdir}/gnome/gconf/schemas/gwd.schemas

%define 	build_kde4 1

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Name:           compiz
URL:            http://www.go-compiz.org
License:        GPL
Group:          User Interface/Desktops
Version:        0.7.6
Release:        2

Summary:        OpenGL window and compositing manager
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:       xorg-x11-server-Xorg
Requires:       mesa-libGL
Requires:       mesa-libGLU
#Requires:       system-logos

# Require for rpm lzma compression transition
Requires:        rpm >= 4.4.2.3-1

Requires(post): desktop-file-utils

BuildRequires:  libX11-devel, libdrm-devel, libwnck-devel libXres-devel
BuildRequires:  libXfixes-devel, libXrandr-devel, libXrender-devel
BuildRequires:  libXcomposite-devel, libXdamage-devel, libXext-devel
BuildRequires:  libXt-devel, libXmu-devel, libICE-devel, libSM-devel
BuildRequires:  gnome-desktop-devel, control-center-devel, GConf-devel
BuildRequires:  desktop-file-utils gnome-menus-devel gnome-panel-devel
BuildRequires:  mesa-libGLU-devel, dbus-devel, dbus-qt3-devel, qt-devel >= 3.3
BuildRequires:  kdelibs-devel, kdebase-devel
BuildRequires:  intltool >= 0.35
BuildRequires:  gettext 
BuildRequires:  dbus-devel
BuildRequires:  librsvg-devel
BuildRequires:  metacity
BuildRequires:  python-devel fuse-userspace-devel
Obsoletes:	beryl-core beryl-manager beryl-plugins beryl-settings beryl-settings-bindings beryl-settings-simple
Source0:        http://xorg.freedesktop.org/archive/individual/app/%{name}-%{version}.tar.bz2
Source1:       desktop-effects-%{dialogversion}.tar.bz2
# The source for this package was pulled from upstream's vcs.  Use the
# following commands to generate the tarball:
# svn checkout https://kagesenshi-private.googlecode.com/svn/trunk/pydesktop-effects pydesktop-effects
# tar -cvf pydesktop-effects-0.1.tar compiz
# bzip2 pydesktop-effects-0.1.tar
Source2:       pydesktop-effects-%{pydialogversion}.tar.bz2

Patch0:		compiz-0.7.4-dualkde.patch
#Patch101: aiglx-defaults.patch
#Patch102: tfp-server-extension.patch
Patch103: composite-cube-logo.patch
#Patch117: close-session.patch
#Patch120: load-glib-before-gconf.patch
#Patch121: default-plugins.patch

%description
Compiz is one of the first OpenGL-accelerated compositing window
managers for the X Window System. The integration allows it to perform
compositing effects in window management, such as a minimization
effect and a cube workspace.  Compiz is an OpenGL compositing manager
that use Compiz use EXT_texture_from_pixmap OpenGL extension extension
for binding redirected top-level windows to texture objects.

%package all
Summary: Compiz meta-package to install all Compiz components
Group: User Interface/Desktops
Requires: %{name} = %{version}-%{release}
Requires: compiz-gnome = %{version}-%{release}
#Requires: compiz-kde = %{version}-%{release}
Requires: compiz-kde4 = %{version}-%{release}
Requires: compiz-fusion-plugins-main >= %{apiversion}
Requires: compiz-fusion-plugins-extra >= %{apiversion}
Requires: ccsm >= %{apiversion}
Requires: fusion-icon-gtk

%description all
Compiz is one of the first OpenGL-accelerated compositing window
managers for the X Window System. The integration allows it to perform
compositing effects in window management, such as a minimization
effect and a cube workspace.  Compiz is an OpenGL compositing manager
that use Compiz use EXT_texture_from_pixmap OpenGL extension extension
for binding redirected top-level windows to texture objects.

This meta package will install all Compiz Fusion component in your computer

%package gnome
Summary: GTK Window decorator for Compiz Fusion and Utilities
Group: User Interface/Desktops
Requires: %{name} = %{version}-%{release}
Requires: gnome-session >= 2.16
Requires: metacity
Requires: libwnck >= 2.15.4
Requires: compizconfig-python >= %{apiversion}

Requires(pre):  GConf
Requires(post): GConf
Requires(preun):GConf

%description gnome
Compiz brings to life a variety of visual effects that make the Linux desktop
easier to use, more powerful and intuitive, and more accessible for users
with special needs.

This package contains a window decorator that provide a look and
feel similar to that of Metacity window manager.

This package will also install together the Emerald decorator
and other compiz utilities

%package kde
Summary: KDE Window decorator for Compiz Fusion and Utilities
Group: User Interface/Desktops
Requires: %{name} = %{version}-%{release}
Requires: fusion-icon-qt

%description kde
Compiz brings to life a variety of visual effects that make the Linux desktop
easier to use, more powerful and intuitive, and more accessible for users
with special needs.

This package contains a window decorator that uses KDE to provide a look and
feel similar to that of the default KDE window manager.

This package will also install together the other compiz utilities

%if %{build_kde4}
%package kde4
Summary: KDE4 Window decorator for Compiz Fusion and Utilities
Group: User Interface/Desktops
Requires: %{name} = %{version}-%{release}
Requires: fusion-icon-qt

%description kde4
Compiz brings to life a variety of visual effects that make the Linux desktop
easier to use, more powerful and intuitive, and more accessible for users
with special needs.

This package contains a window decorator that uses KDE4 to provide a look and
feel similar to that of the default KDE window manager.

This package will also install together the other compiz utilities
%endif

%package kconfig
Summary: KDE configuration backend for compiz
Group: User Interface/Desktops
Requires: %{name} = %{version}-%{release}

%description kconfig
This package provides a KDE config backend for the compiz OpenGL
compositing manager. 

%package devel
Summary: Development packages for compiz
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: pkgconfig
Requires: libX11-devel, libXfixes-devel, libXrender-devel
Requires: libXdamage-devel, libXcomposite-devel
Requires: libXext-devel, libXinerama-devel, libXrandr-devel
Requires: libSM-devel, libpng-devel, startup-notification-devel
Requires: mesa-libGL-devel  mesa-libGLU-devel
Requires: libxml2-devel, libxslt-devel, libdrm-devel
AutoReq:  0

%description devel
The %{name}-devel package includes the header files,
and developer docs for the %{name} package.

Install compiz-devel if you want to develop plugins for the compiz
windows and compositing manager.

%prep
#keep these for now
#%setup -q -T -b1 -n desktop-effects-%{dialogversion}

%setup -q -T -b2 -n pydesktop-effects

%setup -q 
# correct and separate the LDFLAGS for windowdecorator and windowdecorator-kde4
# so they won't mix kde3 and kde4
%patch0 -p1

#%patch121 -p1 -b .default-plugins
#%patch103 -p1 -b .composite-cube-logo


%build
rm -rf $RPM_BUILD_ROOT
#export CXXFLAGS="-L/opt/kde/lib -L/usr/lib/kde4 -I/opt/qt/include $CXXFLAGS"
#export CPPFLAGS="-L/opt/kde/lib -L/usr/lib/kde4 -I/opt/qt/include $CPPFLAGS"

# don't use the %configure macro as it will mix
# kde and kde4 includes and f*ck the whole build up

./configure 	--prefix=/usr \
		--sysconfdir=%_sysconfdir/gnome \
        	--enable-librsvg  \
        	--enable-gnome \
		%if ! %{build_kde4}
                --disable-kde4 \
                %endif
        	--enable-schemas 

make %{?_smp_mflags} imagedir=%{_datadir}/pixmaps

%install
rm -rf $RPM_BUILD_ROOT
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
make DESTDIR=$RPM_BUILD_ROOT install
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL

pushd ../pydesktop-effects
make install DESTDIR=$RPM_BUILD_ROOT
popd

%find_lang compiz
#%find_lang desktop-effects

#cat compiz.lang desktop-effects.lang > all.lang
cat compiz.lang > all.lang

%post
/sbin/ldconfig

%post gnome
/sbin/ldconfig
export GCONF_CONFIG_SOURCE=`/usr/bin/gconftool-2 --get-default-source`
/usr/bin/gconftool-2 --makefile-install-rule %{gconfschemas} >& /dev/null 2>&1|| :
update-desktop-database -q %{_datadir}/applications
touch --no-create %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
      /usr/bin/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
fi

%pre gnome
if [ "$1" -gt 1 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  /usr/bin/gconftool-2 --makefile-uninstall-rule %{gconfschemas} >& /dev/null 2>&1|| :
fi

%preun gnome
if [ "$1" -eq 0 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  /usr/bin/gconftool-2 --makefile-uninstall-rule %{gconfschemas} >& /dev/null 2>&1|| :
fi

%postun gnome
update-desktop-database -q %{_datadir}/applications
touch --no-create %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
      /usr/bin/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
fi


%postun 
/sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files -f compiz.lang
%defattr(-, root, root)
%doc AUTHORS ChangeLog COPYING* INSTALL README TODO
%{_bindir}/compiz
%{_libdir}/libdecoration.so.*
%dir %{_libdir}/compiz
#libglib and libgconf are separated to compiz-gnome
%{_libdir}/compiz/libannotate.so
%{_libdir}/compiz/libblur.so
%{_libdir}/compiz/libclone.so
%{_libdir}/compiz/libcube.so
%{_libdir}/compiz/libdbus.so
%{_libdir}/compiz/libdecoration.so
%{_libdir}/compiz/libfade.so
%{_libdir}/compiz/libfs.so
%{_libdir}/compiz/libini.so
%{_libdir}/compiz/libinotify.so
%{_libdir}/compiz/libminimize.so
%{_libdir}/compiz/libmove.so
%{_libdir}/compiz/libplace.so
%{_libdir}/compiz/libpng.so
%{_libdir}/compiz/libregex.so
%{_libdir}/compiz/libresize.so
%{_libdir}/compiz/librotate.so
%{_libdir}/compiz/libscale.so
%{_libdir}/compiz/libscreenshot.so
%{_libdir}/compiz/libsvg.so
%{_libdir}/compiz/libswitcher.so
%{_libdir}/compiz/libvideo.so
%{_libdir}/compiz/libwater.so
%{_libdir}/compiz/libwobbly.so
%{_libdir}/compiz/libzoom.so

%dir %{_datadir}/compiz
%{_datadir}/compiz/*.png
#glib.xml and gconf.xml are separated to compiz-gnome
%{_datadir}/compiz/annotate.xml
%{_datadir}/compiz/blur.xml
%{_datadir}/compiz/clone.xml
%{_datadir}/compiz/core.xml
%{_datadir}/compiz/cube.xml
%{_datadir}/compiz/dbus.xml
%{_datadir}/compiz/decoration.xml
%{_datadir}/compiz/fade.xml
%{_datadir}/compiz/fs.xml
%{_datadir}/compiz/ini.xml
%{_datadir}/compiz/inotify.xml
%{_datadir}/compiz/minimize.xml
%{_datadir}/compiz/move.xml
%{_datadir}/compiz/place.xml
%{_datadir}/compiz/png.xml
%{_datadir}/compiz/regex.xml
%{_datadir}/compiz/resize.xml
%{_datadir}/compiz/rotate.xml
%{_datadir}/compiz/scale.xml
%{_datadir}/compiz/screenshot.xml
%{_datadir}/compiz/svg.xml
%{_datadir}/compiz/switcher.xml
%{_datadir}/compiz/video.xml
%{_datadir}/compiz/water.xml
%{_datadir}/compiz/wobbly.xml
%{_datadir}/compiz/zoom.xml
%{_datadir}/compiz/schemas.xslt


%files devel
%defattr(-, root, root)
%{_libdir}/pkgconfig/compiz.pc
%{_libdir}/pkgconfig/libdecoration.pc
%{_libdir}/pkgconfig/compiz-cube.pc
%{_libdir}/pkgconfig/compiz-gconf.pc
%{_libdir}/pkgconfig/compiz-scale.pc
%{_includedir}/compiz
%{_libdir}/libdecoration.so
%{_libdir}/*.a
%{_libdir}/*.la
%{_libdir}/compiz/*.a
%{_libdir}/compiz/*.la
%{_libdir}/window-manager-settings/*.a
%{_libdir}/window-manager-settings/*.la


%files all
%defattr(-, root, root)

#%files gnome -f desktop-effects.lang
%files gnome 
%defattr(-, root, root)
%{_bindir}/gtk-window-decorator
%{_sysconfdir}/gnome/gconf/schemas/*.schemas
%{_datadir}/compiz/glib.xml
%{_datadir}/compiz/gconf.xml
%{_libdir}/compiz/libgconf.so
%{_libdir}/compiz/libglib.so
%{_datadir}/gnome-control-center/keybindings/50-compiz-desktop-key.xml
%{_datadir}/gnome-control-center/keybindings/50-compiz-key.xml
%{_datadir}/gnome/wm-properties/compiz.desktop
%{_libdir}/window-manager-settings/libcompiz.so
%{_bindir}/desktop-effects
%{_datadir}/compiz/desktop-effects.glade
%{_datadir}/applications/desktop-effects.desktop
%{_datadir}/icons/hicolor/16x16/apps/desktop-effects.png
%{_datadir}/icons/hicolor/24x24/apps/desktop-effects.png
%{_datadir}/icons/hicolor/32x32/apps/desktop-effects.png
%{_datadir}/icons/hicolor/36x36/apps/desktop-effects.png
%{_datadir}/icons/hicolor/48x48/apps/desktop-effects.png
%{_datadir}/icons/hicolor/96x96/apps/desktop-effects.png


%files kde
%defattr(-, root, root)
%{_bindir}/kde-window-decorator

%if %{build_kde4}
%files kde4
%defattr(-, root, root)
%{_bindir}/kde4-window-decorator
%{_datadir}/compiz/kconfig.xml
%endif

%files kconfig
%defattr(-, root, root)
/opt/kde/share/config.kcfg
/opt/kde/share/config
%{_libdir}/compiz/libkconfig.so
%{_pkgconfig}/compiz-kconfig.pc
%{_datadir}/compiz/kcfg.xslt
%{_datadir}/compiz/kconfig.xslt
%{_datadir}/compiz/kconfig.xml


%changelog
* Sun Jul 27 2008 Karsten Brockmann <arcam@ccux-linux.de> 0.7.6-2
- reenabled kde4 decorator
* Sun Jun 01 2008 Karsten Brockmann <arcam@ccux-linux.de> 0.7.6-1
- Version update
- temporarily disabled kde4 decorator
* Tue May 27 2008 Karsten Brockmann <arcam@ccux-linux.de> 0.7.4-1
- Version update
* Sat Mar 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 0.7.2-1
- Version update
* Mon Oct 22 2007 Christian Metzen <metzench@ccux-linux.de> 0.6.2-2
- fixed requires, added apiversion define
* Sat Oct 20 2007 Karsten Brockmann <arcam@ccux-linux.de> 0.6.2-1
- Version update
* Tue Oct 02 2007 Christian Metzen <metzench@ccux-linux.de> 0.5.2-3
- rebuild against latest libwnck, added obsoletes for beryl
* Thu Sep 20 2007 Christian Metzen <metzench@ccux-linux.de> 0.5.2-2
- fixed dependency
* Thu Sep 20 2007 Christian Metzen <metzench@ccux-linux.de> 0.5.2-1
- Initial release
